#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

/* 
 * Stworzenie struktury ktra zawiera typ wiadomoci i tre
 */
typedef struct {
   long type;
   char body[100];
} msg;

int main(){
   int id;
   int result;
   msg wiad;
   wiad.type = 100;
   strcpy(wiad.body, "Hello World test"); // strcpy( dest, src )
   id = msgget(1642, IPC_CREAT | 0666); // msgget - tworzy kolejke
   // nr kolejki, prawa dostpu
   // zwracana warto: <0 - bd; >=0 id kolejki
   if(id < 0){
      printf("Msgget: %d\n", id);
      exit(1);
   }
   result = msgsnd(id, &wiad, strlen(wiad.body), 0); // wysyanie wiadomoci
   // identyfikator kolejki, * komunikat, dugo treci komunikatu, flaga 
   // okrelajca zachowanie w przypadku, jeli dugo jest wiksza ni ta podana jako
   // drugi parametr
   printf("%d\n", result); // wywietlenie komunikatu o wyniku wysania
   return 0;
}
